; Sparring MenuSpy by kero
; http://files.rsdn.ru/42164/menuspy.zip
; upd: raw draft v 2014-01-19

; ml /c /coff /I\masm32\include %name%.asm
; link /subsystem:windows   /libpath:\masm32\lib /dll /def:%name%.def /section:.bss,S %name%.obj
; link /subsystem:windows,6 /libpath:\masm32\lib /dll /def:%name%.def /section:.bss,S %name%.obj

.386
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib

MENUITEMINFO_ struct
  cbSize            DWORD ?
  fMask             DWORD ?
  fType             DWORD ?
  fState            DWORD ?
  wID               DWORD ?
  hSubMenu          DWORD ?
  hbmpChecked       DWORD ?
  hbmpUnchecked     DWORD ?
  dwItemData        DWORD ?
  dwTypeData        DWORD ?
  cch               DWORD ?
  hbmpItem          DWORD ? ; (? masm32)
MENUITEMINFO_ ends

.const
  kk            equ 300

.data
  _user32        db "user32",0
  _setsystemmenu db "SetSystemMenu",0
  _restore       db "Restore",0
  _move          db "Move",0
  _size          db "Size",0
  _minimize      db "Minimize",0
  _maximize      db "Maximize",0
  _close         db "Close",0
  _tasklist      db "Tasklist",0
  _screensave    db "Screensave",0
  _sp            db " ",0
  hinst          dd 0

.data?
  hhook          dd ?
  hwin           dd ?
  hmenu          dd ?
  hmn            dd ?
  num            dd ?

.code

SetSysMenuImg proc uses edi hMenu:HMENU
  local mii:MENUITEMINFO_
  invoke GetSubMenu,hMenu,0
  mov edi,eax
  invoke RtlZeroMemory,addr mii,sizeof mii
  mov mii.cbSize,sizeof mii
  mov mii.fMask,MIIM_BITMAP
  mov mii.hbmpItem,HBMMENU_POPUP_RESTORE
  invoke SetMenuItemInfo,edi,0,MF_BYPOSITION,addr mii
  mov mii.hbmpItem,HBMMENU_POPUP_MINIMIZE
  invoke SetMenuItemInfo,edi,3,MF_BYPOSITION,addr mii
  mov mii.hbmpItem,HBMMENU_POPUP_MAXIMIZE
  invoke SetMenuItemInfo,edi,4,MF_BYPOSITION,addr mii
  mov mii.hbmpItem,HBMMENU_POPUP_CLOSE
  invoke SetMenuItemInfo,edi,6,MF_BYPOSITION,addr mii
  mov mii.hbmpItem,HBMMENU_SYSTEM
  invoke SetMenuItemInfo,edi,8,MF_BYPOSITION,addr mii
  mov ecx,edi
  mov eax,hMenu
  ret
SetSysMenuImg endp

CreateSysMenu proc uses ebx edi
  invoke CreateMenu
  mov ebx,eax
  invoke CreatePopupMenu
  mov edi,eax
  invoke AppendMenu,ebx,MF_POPUP,edi,offset _sp
  invoke AppendMenu,edi,MF_STRING,0F120h,offset _restore
  invoke AppendMenu,edi,MF_STRING,0F010h,offset _move
  invoke AppendMenu,edi,MF_STRING,0F000h,offset _size
  invoke AppendMenu,edi,MF_STRING,0F020h,offset _minimize
  invoke AppendMenu,edi,MF_STRING,0F030h,offset _maximize
  invoke AppendMenu,edi,MF_SEPARATOR,0,0
  invoke AppendMenu,edi,MF_STRING,0F060h,offset _close
  invoke AppendMenu,edi,MF_SEPARATOR,0,0
  invoke AppendMenu,edi,MF_STRING,0F130h,offset _tasklist
  invoke AppendMenu,edi,MF_STRING,0F140h,offset _screensave    
  invoke SetSysMenuImg,ebx  
  ret
CreateSysMenu endp

LoadSysMenu proc 
  invoke LoadMenu,hinst,kk
  invoke SetSysMenuImg,eax
  ret
LoadSysMenu endp

HookProc proc uses ebx edi esi nCode:DWORD,wParam:DWORD,lParam:DWORD
  .if nCode==HCBT_SYSCOMMAND
    mov eax,num
    .if eax==0 || eax==1
      invoke GetSystemMenu,hwin,eax
      mov hmenu,eax    
    .elseif eax==2
      invoke CreateSysMenu
      jmp @f
    .elseif eax==3
      invoke LoadSysMenu
      jmp @f
    .elseif eax==4
      mov eax,hmn
@@:
      mov hmenu,eax
      invoke GetModuleHandle,offset _user32
      invoke GetProcAddress,eax,offset _setsystemmenu
      test eax,eax
      jz @@@
      push hmenu      
      push hwin      
      call eax
    .elseif eax==5
      mov eax,hmn
      mov hmenu,eax
      invoke TrackPopupMenuEx,eax,0,0,0,hwin,0
    .else
@@@:
      xor eax,eax
      mov hmenu,eax
    .endif
    xor eax,eax
  .endif
  invoke CallNextHookEx,hhook,nCode,wParam,lParam
	ret
HookProc endp

Inject proc hWnd:HWND,tid:DWORD,hMenu:HMENU,Num:DWORD
  mov eax,hWnd
  mov hwin,eax
  mov eax,hMenu
  mov hmn,eax
  mov eax,Num
  mov num,eax
  invoke SetWindowsHookEx,WH_CBT,offset HookProc,hinst,tid
  mov hhook,eax
  invoke SendMessageTimeout,hwin,WM_SYSCOMMAND,SC_DEFAULT,0,SMTO_ABORTIFHUNG,300,0
  invoke Sleep,100
  invoke UnhookWindowsHookEx,hhook
  invoke PostMessage,hwin,WM_NULL,0,0
  mov eax,hmenu
	ret 
Inject endp

DllEntry proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD
  .if reason==DLL_PROCESS_ATTACH
    mov eax,hInst
    mov hinst,eax
  .endif
	mov eax,TRUE
	ret
DllEntry Endp

End DllEntry
